//
// Created by martin on 19.08.19.
//

#ifndef LIB4NEURO_ACSFNEURALNETWORK_H
#define LIB4NEURO_ACSFNEURALNETWORK_H

#include <unordered_map>
#include <string>

#include "../message.h"

#include "NeuralNetwork.h"
#include "../DataSet/DataSet.h"
#include "../SymmetryFunction/SymmetryFunction.h"

namespace lib4neuro {
    class ACSFNeuralNetwork : public NeuralNetwork {
    private:
        std::unordered_map<ELEMENT_SYMBOL, Element*>* elements;

        std::vector<ELEMENT_SYMBOL>* elements_list;

    public:

        /**
        * Struct used to access private properties from
        * the serialization function
        */
        struct access;

        LIB4NEURO_API explicit ACSFNeuralNetwork(std::unordered_map<ELEMENT_SYMBOL, Element*>& elements,
                                                 std::vector<ELEMENT_SYMBOL>& elements_list,
                                                 bool with_charge,
                                                 std::unordered_map<ELEMENT_SYMBOL, std::vector<unsigned int >> n_hidden_neurons,
                                                 std::unordered_map<ELEMENT_SYMBOL, std::vector<NEURON_TYPE>> type_hidden_neurons);

        LIB4NEURO_API explicit ACSFNeuralNetwork(std::string filepath);

        [[deprecated]] LIB4NEURO_API void load_structure_from_file(const std::string& filepath );

        LIB4NEURO_API std::unordered_map<ELEMENT_SYMBOL, Element*>* get_elements();

        LIB4NEURO_API std::vector<ELEMENT_SYMBOL>* get_elements_list();
    };
}

#endif //LIB4NEURO_ACSFNEURALNETWORK_H
