//
// Created by martin on 07.11.19.
//

#ifndef LIB4NEURO_ACSFNEURALNETWORKSERIALIZATION_H
#define LIB4NEURO_ACSFNEURALNETWORKSERIALIZATION_H

#include <boost/random/mersenne_twister.hpp>
#include <boost/random/uniform_real_distribution.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/list.hpp>
#include <boost/serialization/string.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/utility.hpp>
#include <boost/serialization/shared_ptr.hpp>

#include "ACSFNeuralNetwork.h"
#include "Neuron/NeuronSerialization.h"
#include "Neuron/NeuronBinarySerialization.h"
#include "Neuron/NeuronConstantSerialization.h"
#include "Neuron/NeuronLinearSerialization.h"
#include "Neuron/NeuronLogisticSerialization.h"
#include "NetConnection/ConnectionFunctionGeneralSerialization.h"
#include "NetConnection/ConnectionFunctionIdentitySerialization.h"

BOOST_CLASS_EXPORT_KEY(lib4neuro::ACSFNeuralNetwork);

namespace lib4neuro {
    struct ACSFNeuralNetwork::access {
        template<class Archive>
        static void serialize(Archive& ar,
                              ACSFNeuralNetwork& nn,
                              const unsigned int version) {
            ar & boost::serialization::base_object<NeuralNetwork>(nn);
            ar & elements;
            ar & elements_list;
        }
    };
}

namespace boost {
    namespace serialization {

        /**
         * Serialization function
         * @tparam Archive Boost library template
         * @param ar Boost parameter - filled automatically during serialization!
         * @param ds NeuralNetwork instance
         * @param version Boost parameter - filled automatically during serialization!
         */
        template<class Archive>
        void serialize(Archive& ar,
                       lib4neuro::ACSFNeuralNetwork& nn,
                       const unsigned int version) {
            lib4neuro::ACSFNeuralNetwork::access::serialize(ar,
                                                            nn,
                                                            version);
        }
    } // namespace serialization
} // namespace boost

#endif //LIB4NEURO_ACSFNEURALNETWORKSERIALIZATION_H
