//
// Created by martin on 13.11.19.
//

#ifndef LIB4NEURO_NORMALIZATIONSTRATEGYACSFSERIALIZATION_H
#define LIB4NEURO_NORMALIZATIONSTRATEGYACSFSERIALIZATION_H

#include <boost/serialization/base_object.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/unordered_map.hpp>

#include "NormalizationStrategyACSF.h"
#include "NormalizationStrategySerialization.h"

BOOST_CLASS_EXPORT_KEY(lib4neuro::NormalizationStrategyACSF)

struct lib4neuro::NormalizationStrategyACSF::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          NormalizationStrategyACSF& ns,
                          const unsigned int version) {
        ar & boost::serialization::base_object<NormalizationStrategy>(ns);
        ar & ns.inputs_min;
        ar & ns.inputs_max;
        ar & ns.outputs_min;
        ar & ns.outputs_max;
        ar & ns.number_of_inputs_per_element;
        ar & ns.order_of_elements;
    }

//    template<class Archive>
//    static void save_construct_data(Archive & ar,
//                                    const NormalizationStrategyACSF * ns,
//                                    const unsigned int file_version){
//        ar & boost::serialization::base_object<NormalizationStrategy>(ns);
//        ar & ns->inputs_min;
//        ar & ns->inputs_max;
//        ar & ns->outputs_min;
//        ar & ns->outputs_max;
//        ar & ns->number_of_inputs_per_element;
//        ar & ns->order_of_elements;
//    }
//
//    template<class Archive>
//    static void load_construct_data(
//        Archive & ar, NormalizationStrategyACSF * ns, const unsigned int file_version
//    ){
//        ar & boost::serialization::base_object<NormalizationStrategy>(ns);
//        ar & ns->inputs_min;
//        ar & ns->inputs_max;
//        ar & ns->outputs_min;
//        ar & ns->outputs_max;
//        ar & ns->number_of_inputs_per_element;
//        ar & ns->order_of_elements;
//    }
};

namespace boost {
    namespace serialization {

        /**
         * Serialization function
         * @tparam Archive Boost library template
         * @param ar Boost parameter - filled automatically during serialization!
         * @param ns NormalizationStrategyACSF instance
         * @param version Boost parameter - filled automatically during serialization!
         */
        template<class Archive>
        void serialize(Archive& ar,
                       lib4neuro::NormalizationStrategyACSF& ns,
                       const unsigned int version) {
            lib4neuro::NormalizationStrategyACSF::access::serialize(ar,
                                                                    ns,
                                                                    version);
        }

//        template<class Archive>
//        void save_construct_data(
//            Archive & ar, const lib4neuro::NormalizationStrategyACSF* ns, const unsigned int file_version){
//            lib4neuro::NormalizationStrategyACSF::access::save_construct_data(ar, ns, file_version);
//        }
//
//        template<class Archive>
//        inline void load_construct_data(
//            Archive & ar, const lib4neuro::NormalizationStrategyACSF* ns, const unsigned int file_version
//        ){
//            lib4neuro::NormalizationStrategyACSF::access::save_construct_data(ar, ns, file_version);
//        }
    } // namespace serialization
} // namespace boost


#endif //LIB4NEURO_NORMALIZATIONSTRATEGYACSFSERIALIZATION_H
