//
// Created by martin on 12.08.19.
//

#include <boost/serialization/export.hpp>

#include "Element.h"
#include "ElementSerialization.h"

BOOST_CLASS_EXPORT_IMPLEMENT(lib4neuro::Element)

const std::string& lib4neuro::Element::getElementSymbol() const {
    return element_symbol;
}

std::vector<lib4neuro::SymmetryFunction*>* lib4neuro::Element::getSymmetryFunctions() {
    return &symmetry_functions;
}

lib4neuro::Element::Element(const std::string& element_symbol,
                            std::vector<SymmetryFunction*>& symmetry_functions
                            ) {
    this->element_symbol = element_symbol;
    this->symmetry_functions = symmetry_functions;
}

/**
 * Constructor for Boost serialization.
 */
lib4neuro::Element::Element() {}
