//
// Created by martin on 12.08.19.
//

#ifndef LIB4NEURO_ELEMENT_H
#define LIB4NEURO_ELEMENT_H

#include <string>
#include <vector>

#include "../settings.h"
#include "../SymmetryFunction/SymmetryFunction.h"
#include "../Neuron/Neuron.h"

namespace lib4neuro {
    class Element {
    public:
        Element();

        LIB4NEURO_API Element(const std::string& element_symbol,
                              std::vector<SymmetryFunction*>& symmetry_functions);

        LIB4NEURO_API [[nodiscard]] const std::string& getElementSymbol() const;
        LIB4NEURO_API [[nodiscard]] std::vector<SymmetryFunction*>* getSymmetryFunctions();

        struct access;

    protected:
        std::string                      element_symbol;
        std::vector<SymmetryFunction*>   symmetry_functions;
    };
}

#endif //LIB4NEURO_ELEMENT_H
