//
// Created by martin on 02.08.19.
//

#ifndef LIB4NEURO_SYMMETRYFUNCTIONSERIALIZATION_H
#define LIB4NEURO_SYMMETRYFUNCTIONSERIALIZATION_H

#include <boost/serialization/base_object.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/vector.hpp>

#include "SymmetryFunction.h"

BOOST_SERIALIZATION_ASSUME_ABSTRACT(lib4neuro::SymmetryFunction)
BOOST_CLASS_EXPORT_KEY(lib4neuro::SymmetryFunction)
BOOST_CLASS_EXPORT_KEY(lib4neuro::G1)
BOOST_CLASS_EXPORT_KEY(lib4neuro::G2)
BOOST_SERIALIZATION_ASSUME_ABSTRACT(lib4neuro::CutoffFunction)
BOOST_CLASS_EXPORT_KEY(lib4neuro::CutoffFunction1)
BOOST_CLASS_EXPORT_KEY(lib4neuro::CutoffFunction2)

struct lib4neuro::SymmetryFunction::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          lib4neuro::SymmetryFunction& sf,
                          const unsigned int version) {
        ar & sf.cutoff_func;
    }
};

struct lib4neuro::G1::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          lib4neuro::G1& sf,
                          const unsigned int version) {
        ar & boost::serialization::base_object<lib4neuro::SymmetryFunction>(sf);
    }
};

struct lib4neuro::G2::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          lib4neuro::G2& sf,
                          const unsigned int version) {
        ar & boost::serialization::base_object<lib4neuro::SymmetryFunction>(sf);
    }
};

struct lib4neuro::CutoffFunction::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          lib4neuro::CutoffFunction& f,
                          const unsigned int version) {
    }
};

struct lib4neuro::CutoffFunction1::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          lib4neuro::CutoffFunction1& f,
                          const unsigned int version) {
        ar & boost::serialization::base_object<lib4neuro::CutoffFunction>(f);
    }
};

struct lib4neuro::CutoffFunction2::access {
    template<class Archive>
    static void serialize(Archive& ar,
                          lib4neuro::CutoffFunction2& f,
                          const unsigned int version) {
        ar & boost::serialization::base_object<lib4neuro::CutoffFunction>(f);
    }
};

namespace boost::serialization {

    template<class Archive>
    void serialize(Archive& ar,
                   lib4neuro::SymmetryFunction& f,
                   const unsigned int version) {
        lib4neuro::SymmetryFunction::access::serialize(ar, f, version);
    }

    template<class Archive>
    void serialize(Archive& ar,
                   lib4neuro::G1& f,
                   const unsigned int version) {
        lib4neuro::G1::access::serialize(ar, f, version);
    }

    template<class Archive>
    void serialize(Archive& ar,
                   lib4neuro::G2& f,
                   const unsigned int version) {
        lib4neuro::G2::access::serialize(ar, f, version);
    }

    template<class Archive>
    void serialize(Archive& ar,
                   lib4neuro::CutoffFunction& f,
                   const unsigned int version) {
        lib4neuro::CutoffFunction::access::serialize(ar, f, version);
    }

    template<class Archive>
    void serialize(Archive& ar,
                   lib4neuro::CutoffFunction1& f,
                   const unsigned int version) {
        lib4neuro::CutoffFunction1::access::serialize(ar, f, version);
    }

    template<class Archive>
    void serialize(Archive& ar,
                   lib4neuro::CutoffFunction2& f,
                   const unsigned int version) {
        lib4neuro::CutoffFunction2::access::serialize(ar, f, version);
    }
} // namespace boost

#endif //LIB4NEURO_SYMMETRYFUNCTIONSERIALIZATION_H
